/*
ͻ
 NOM       : MODEM.C                                                         
 FONCTION  : Bibliothque pour commander et contrler le modem utilis       
           : (TlTex ou HAYES pour l'instant...)                            
 REMARQUES :  Pour activer l'interruption d'horloge de cette unit, il faut 
           : insrer la ligne suivante dans le programme principal:          
           :         install_Clock();                                        
           : Ne pas oublier de dsactiver avant de quitter le programme:     
           :         un_install_Clock();                                     
           : Cette interruption tiendra  jour la variable "connected" de    
           : seconde en seconde pour un modem Hayes. Elle permet galement   
           : l'affichage du tmoin de connexion (si "Show_CorF" vaut TRUE).  
           : Notez que "HayesModemState" et "Check_HModem_State" ne sont     
           : d'aucun secours pour contrler l'tat de connexion du minitel:  
           : l'tat de connex. de ce dernier doit tre interprt par votre  
           : routine de dcodage du VidoTex...                              
           :  Tenez  jour la variable 'num_com'.                           
           :  La prsence d'une ligne assembleur dans ce listing rend l'uti-
           : -lisation de TCC ncessaire pour effectuer une compilation...   
 COPYRIGHT : HETRU Fabrice 1991-1993.                                        
ͼ
*/



#include <dos.h>
#include <string.h>

#define  byte    unsigned char

#define  Int1C   0x1C  /* N d'int. BIOS grant l'interrupt. d'horloge.      */
#define  FALSE   0     /* Valeur logique "FAUX".                             */
#define  TRUE    1     /* Valeur logique "VRAI".                             */

/* Codes du type de modem utilis: MINITEL ou HAYES ? */
#define  TlTex     0
#define  Hayes     1
/* Codes de commande  envoyer au Modem utilis.      */
#define  Generique 0
#define  InitMod   1
#define  Connect   2
#define  Appel     3
#define  Raccroch  4
#define  ConnexFin 5

/* Variables utiles  l'interfaage de cette bibliothque. */
byte     ModemUsed = Hayes;       /* Type du modem utilis: Hayes/Minitel ?  */
byte     DTR_Cmde = TRUE;         /* Utilisation de DTR comme prfixe-cmde ? */
byte     HAYESPrefix[4] = {'+','+','+',0}; /* Prfixe de cmde modems-HAYES.  */
byte     PulseDial = TRUE;        /* Numrotation par impulsions ?           */
byte     num_com = 1;             /* Port srie utilis ? (1  4).           */
byte     connected = FALSE;       /* Indique l'tat de la connexion.         */
byte     Show_CorF = FALSE;       /* Affichage du tmoin de connexion ?      */
byte     ItClk_active = FALSE;    /* It_clk en cours d'excution ?           */

/* Codes et commandes spciales de contrle des modems, */
/* pouvant faire l'objet d'une adaptation...            */
/* Le caractre 0 hexa. plac en fin de chaque code     */
/* est ncessaire pour traiter les codes au moyen des   */
/* oprateurs de chaine du langage C.                   */
char     Esc[2] = {0x1B,0};
char     Sep[2] = {0x13,0};
char     Pro1[2] = {0x39,0};
char     Cod1[2] = {0x67,0};
char     Cod2[2] = {0x68,0};
char     Cod3[2] = {0x49,0};
char     HayesCod[3] = "AT";
char     PulsD[2] = {'P',0};
char     FreqD[2] = {'T',0};
char     HayesInit[17] = " Z0 &D1 X0 V2 B2";
char     HayesConnect[2] = "D";
char     HayesDeconnex[3] = "H0";
char     Lfeed[2] = {0x0D,0};

/* Variables internes d'utilit gnrale. */
union    REGS inregs,outregs;
struct   SREGS segregs;
int      Curs_C = 0x7043;
int      Curs_F = 0x7046;
unsigned int seg_ecran;



#include "STARINTF.C"


void Beep(int Freq, int Tempo)
  {
  sound(Freq);
  delay(Tempo);
  nosound();
  }


void CmdeToModem(byte TypCmde, char *DataCmde)
  {
  char Chaine_CMDE[30];
  unsigned int Nb_transmited;
  byte Sended;

  Nb_transmited = 0;
  strcpy(Chaine_CMDE,'');
  switch (ModemUsed)
    {
    case TlTex:
      {
      strcpy(Chaine_CMDE,Esc);
      switch (TypCmde)
        {
        case Generique:
          { strcat(Chaine_CMDE,Pro1); strcat(Chaine_CMDE,Cod1); break; }
        case InitMod:
          { strcpy(Chaine_CMDE,''); break; }
        case Connect:
          { strcat(Chaine_CMDE,Pro1); strcat(Chaine_CMDE,Cod2); break; }
        case Appel:
          { strcpy(Chaine_CMDE,''); break; }
        case Raccroch:
          { strcat(Chaine_CMDE,Pro1); strcat(Chaine_CMDE,Cod1); break; }
        case ConnexFin:
          {
          if (connected)
            {
            strcat(Chaine_CMDE,Sep);
            strcat(Chaine_CMDE,Cod3);
            }
          else
            {
            strcat(Chaine_CMDE,Pro1);
            strcat(Chaine_CMDE,Cod2);
            }
          }
        }
      if (strlen(Chaine_CMDE)>0)
        {
        strcat(Chaine_CMDE,Lfeed);
        if (WriteSerie(Chaine_CMDE,strlen(Chaine_CMDE),&Nb_transmited)!=0)
          Beep(500,500);
        }
      break;
      }
    case Hayes:
      {
      if (TypCmde!=Generique) strcat(Chaine_CMDE,HayesCod);
      switch (TypCmde)
        {
        case Generique: { strcat(Chaine_CMDE,DataCmde); break; }
        case InitMod:
          {
          strcat(Chaine_CMDE,HayesInit);
          break;
          }
        case Connect:
          {
          strcat(Chaine_CMDE,HayesConnect);
          break;
          }
        case Appel:
          {
          if (connected | (DataCmde==''))
            strcpy(Chaine_CMDE,'');
          else
            {
            strcat(Chaine_CMDE,HayesConnect);
            if (PulseDial) strcat(Chaine_CMDE,PulsD);
              else strcat(Chaine_CMDE,FreqD);
            strcat(Chaine_CMDE,DataCmde);
            }
          break;
          }
        case Raccroch: { strcat(Chaine_CMDE,HayesDeconnex); break; }
        case ConnexFin: if (connected) strcat(Chaine_CMDE,HayesDeconnex);
                     else strcat(Chaine_CMDE,HayesConnect);
        }
      if (strlen(Chaine_CMDE)>0)
        {
        if (!DTR_Cmde)
          {
          if (connected)
            {
            delay(1000);
            Sended = WriteCmde(HAYESPrefix,strlen(HAYESPrefix),DTR_Cmde);
            if (Sended==0) delay(1000);
            }
          else Sended = 0;
          }
        else Sended = 0;
        if (Sended==0)
          {
          strcat(Chaine_CMDE,Lfeed);
          if (WriteCmde(Chaine_CMDE,strlen(Chaine_CMDE),DTR_Cmde)!=0)
            Beep(500,500);
          if (connected)
            {
            delay(1200);
            strcpy(Chaine_CMDE,"ATO");
            strcat(Chaine_CMDE,Lfeed);
            Sended = WriteCmde(Chaine_CMDE,strlen(Chaine_CMDE),FALSE);
            }
          }
        }
      }
    }
  }


void HayesModemState()
  {
  byte ModemStatus;

  ModemStatus = 0;
  if (ModemUsed==Hayes)
    {
    switch (num_com)
      {
      case 1: { ModemStatus = inportb(BasePort1+6) && 0x80; break; }
      case 2: { ModemStatus = inportb(BasePort2+6) && 0x80; break; }
      case 3: { ModemStatus = inportb(BasePort3+6) && 0x80; break; }
      case 4: ModemStatus = inportb(BasePort4+6) && 0x80;
      }
    if (ModemStatus==0x80) connected = TRUE;
      else connected = FALSE;
    }
  }


static void interrupt (*OldIClk) ();


void interrupt Check_HModem_State()
  {
  static byte compteur = 0;
  char mod_scr;

  /* Activation traitement toutes les secondes  peu prs... */
  compteur++;
  if ( (compteur>=0x12) & (!ItClk_active) )
    {
    /* Interdiction de r-entrance. */
    ItClk_active = TRUE;

    /* Acquitement 8259 et CPU pour permettre rceptions sries... */
    outportb(0x20,0x20);
    enable();

    /* Vrification de l'tat de la connexion. */
    HayesModemState();

    /* Gestion du tmoin de connexion si ncessaire. */
    if (Show_CorF)
      {
      mod_scr = peekb(0x40,0x49);
      if (connected)
        {
        if ( (mod_scr==2) | (mod_scr==3) | (mod_scr==7) )
          poke(seg_ecran,158,Curs_C);
        else poke(seg_ecran,76,Curs_C);
        }
      else
        {
        if ( (mod_scr==2) | (mod_scr==3) | (mod_scr==7) )
          poke(seg_ecran,158,Curs_F);
        else poke(seg_ecran,76,Curs_F);
        }
      }

    /* Reset tmoins de gnration de la prsente interruption. */
    ItClk_active = FALSE;
    compteur = 0;
    }

  /* Appel imbriqu de l'ancienne IT_Clk... */
  asm pushf
  (*OldIClk) ();
  }


void install_Clock(byte com)
  {
  inregs.h.ah = 0x0F;
  int86(0x10,&inregs,&outregs);
  if (outregs.h.al==7) seg_ecran = 0xB000;
    else seg_ecran = 0xB800;
  num_com = com;
  OldIClk = getvect(Int1C);
  setvect(Int1C,Check_HModem_State);
  }


void un_install_Clock()
  {
  setvect(Int1C,OldIClk);
  }
